/*                               -*- Mode: C -*- 
 * timer_create.c -- 
 * Copyright (c) 1991-2003 Francois Felix Ingrand.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *    - Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *    - Redistributions in binary form must reproduce the above
 *      copyright notice, this list of conditions and the following
 *      disclaimer in the documentation and/or other materials provided
 *      with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * 
 * $Id: timer_create.c,v 1.1 2003/10/21 08:12:20 felix Exp $
 */

#include <vxWorks.h>
#include <timers.h>

/***
 *** Function to unify the VxWorks 5.1 and 5.2 version of timer_create.
 ***/

STATUS vw_5_2_timer_create(
#ifdef VW_5_1_1
    clock_t clock_id,
#else
    clockid_t clock_id,
#endif
    struct sigevent *evp,
    timer_t *pTimer)
{
#ifdef VW_5_1_1
    timer_t timerId;

    timerId = timer_create(clock_id, evp);
    if (timerId == (timer_t)ERROR) {
	*pTimer = NULL;
	return(ERROR);
    } else {
	*pTimer = timerId;
	return(OK);
    }
#else
    return(timer_create(clock_id, evp, pTimer));
#endif

} /* vw_5_2_timer_create */
