%{

/*                               -*- Mode: C -*- 
 * op-editor-parser.l -- Lex parser
 * 
 * $Id: ope-parser.l,v 1.1 2003/10/21 08:12:15 felix Exp $
 * 
 * Copyright (c) 1991-2003 Francois Felix Ingrand.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *    - Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *    - Redistributions in binary form must reproduce the above
 *      copyright notice, this list of conditions and the following
 *      disclaimer in the documentation and/or other materials provided
 *      with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 */

#include "config.h"
#include <stdlib.h>
#include <sys/file.h>


#include "constant.h"
#include "macro.h"
#include "opaque.h"
#include "oprs-type.h"
#include "op-structure.h"
#include "parser-funct.h"

#include "oprs-type_f.h"
#include "parser-funct_f.h"

#include "ope-parser.tab.h"

include "lex-simple-def.l"

include "lex-parser-def.l"

%}

include "lex-macro.l"

id {untypedid}

%s COMMAND OPF_VERSION NODE_TYPE FIELD_TYPE EDGE_TYPE ACTION_TYPE COLLECT_COMMENT

%%
{ws}					;
<COMMAND>echo_t_or_nil			{return ECHO_T_OR_NIL; }
<COMMAND>echo_string			{return ECHO_STRING; }
<COMMAND>echo_gexpr			{return ECHO_GEXPR; }
<COMMAND>echo_expr			{return ECHO_EXPR; }
<COMMAND>echo_gtexpr			{return ECHO_GTEXPR; }
<COMMAND>echo_gmexpr			{return ECHO_GMEXPR; }
<COMMAND>echo_gmexpr_or_nil		{return ECHO_GMEXPR_NIL; }
<COMMAND>echo_lgtexpr			{return ECHO_LGTEXPR; }
<COMMAND>echo_eff			{return ECHO_EFF; }
<COMMAND>echo_ctxt			{return ECHO_CTXT; }
<COMMAND>echo_pl			{return ECHO_PL; }
<COMMAND>echo_id			{return ECHO_ID; }
<COMMAND>echo_term			{return ECHO_TERM; }
<COMMAND>echo_action			{return ECHO_ACTION; }
<COMMAND>echo_body			{return ECHO_BODY; }
<COMMAND>compile_ops			{return COMPILE_OP; }
<COMMAND>append_ops			{return APPEND_OP; }
<COMMAND>convert_ops			{return CONVERT_OP; }
<COMMAND>convert_text_ops		{return CONVERT_TEXT_OP; }
<COMMAND>copy_op			{return COPY_OP; }
<COMMAND>exit   			{return EXIT; }

include "lex-graph-op.l"

include "lex-text-op.l"

include "lex-meta-exp.l"

include "lex-exp.l"

%%
#include "yy-funct.c"

void yy_begin_0()
{
     BEGIN 0;
}

void yy_begin_COMMAND()
{
     BEGIN COMMAND;
}

void yy_begin_OPF_VERSION(void)
{
     BEGIN OPF_VERSION;
}

void yy_begin_NODE_TYPE(void)
{
     BEGIN NODE_TYPE;
}

void yy_begin_FIELD_TYPE(void)
{
     BEGIN FIELD_TYPE;
}

void yy_begin_ACTION_TYPE(void)
{
     BEGIN ACTION_TYPE;
}

void yy_begin_EDGE_TYPE(void)
{
     BEGIN EDGE_TYPE;
}

void yy_begin_COLLECT_COMMENT(void)
{
     BEGIN COLLECT_COMMENT;
}

