%{



#include "config.h"
#include <stdlib.h>
#include <sys/file.h>


#include "constant.h"
#include "macro.h"
#include "opaque.h"
#include "oprs-type.h"
#include "op-structure.h"
#include "parser-funct.h"

#include "oprs-type_f.h"
#include "parser-funct_f.h"

#include "ope-parser.tab.h"






#include "shashPack_f.h"







#define YY_INPUT(buf,result,max_size) \
	if ( YY_CURRENT_BUFFER->yy_is_interactive ) \
		{ \
		int c = '*', n; \
		for ( n = 0; n < max_size && \
			     (c = getc( yyin )) != EOF && c != '\n'; ++n ) \
			buf[n] = (char) c; \
		if ( c == '\n' ) \
			buf[n++] = (char) c; \
		if ( c == EOF && ferror( yyin ) ) \
			YY_FATAL_ERROR( "input in flex scanner failed" ); \
		result = n; \
		} \
	else if ( ((result = fread( buf, 1, max_size, yyin )) == 0) \
		  && (parse_source == PS_FILE) && ferror( yyin ) ) \
		YY_FATAL_ERROR( "input in flex scanner failed" );


%}





ws		[ \t]+
real 		[-\+]?[0-9]+\.[0-9]*
exp		[eE][-\+]?[0-9]+
integer 	[-\+]?[0-9]+[l]?
long_long 	[-\+]?[0-9]+ll
pointer 	0x[0123456789abcdefABCDEF]+
comment		;.*$
qstring 	\"([^"]|\\["])*\" 
untypedid	([^ \t\n~0123456789"&\(\)\$@;\|\.[\]][^ \t\n"\(\)\]]*)
typedid 	([^ \t\n~0123456789:"&\(\)\$@;\|\.[\]][^ \t\n:"\(\)\]]*)

idbar   	(\|[^|]+\|)
nl		\n
or		V
and		&
op		\(
cp		\)
opar		\[
cpar		\]
oplisp		\(\.
cplisp		\.\)
lvar		\${id}
pvar		@{id}
gpvar		@@{id}


id {untypedid}

%s COMMAND OPF_VERSION NODE_TYPE FIELD_TYPE EDGE_TYPE ACTION_TYPE COLLECT_COMMENT

%%
{ws}					;
<COMMAND>echo_t_or_nil			{return ECHO_T_OR_NIL; }
<COMMAND>echo_string			{return ECHO_STRING; }
<COMMAND>echo_gexpr			{return ECHO_GEXPR; }
<COMMAND>echo_expr			{return ECHO_EXPR; }
<COMMAND>echo_gtexpr			{return ECHO_GTEXPR; }
<COMMAND>echo_gmexpr			{return ECHO_GMEXPR; }
<COMMAND>echo_gmexpr_or_nil		{return ECHO_GMEXPR_NIL; }
<COMMAND>echo_lgtexpr			{return ECHO_LGTEXPR; }
<COMMAND>echo_eff			{return ECHO_EFF; }
<COMMAND>echo_ctxt			{return ECHO_CTXT; }
<COMMAND>echo_pl			{return ECHO_PL; }
<COMMAND>echo_id			{return ECHO_ID; }
<COMMAND>echo_term			{return ECHO_TERM; }
<COMMAND>echo_action			{return ECHO_ACTION; }
<COMMAND>echo_body			{return ECHO_BODY; }
<COMMAND>compile_ops			{return COMPILE_OP; }
<COMMAND>append_ops			{return APPEND_OP; }
<COMMAND>convert_ops			{return CONVERT_OP; }
<COMMAND>convert_text_ops		{return CONVERT_TEXT_OP; }
<COMMAND>copy_op			{return COPY_OP; }
<COMMAND>exit   			{return EXIT; }






<OPF_VERSION>1				{return OPF_VERSION1;}
<OPF_VERSION>2				{return OPF_VERSION2;}

<FIELD_TYPE>INVOCATION			{return FT_INVOCATION_TK;}
<FIELD_TYPE>CONTEXT			{return FT_CONTEXT_TK;}
<FIELD_TYPE>CALL			{return FT_CALL_TK;}
<FIELD_TYPE>SETTING			{return FT_SETTING_TK;}
<FIELD_TYPE>PROPERTIES			{return FT_PROPERTIES_TK;}
<FIELD_TYPE>DOCUMENTATION		{return FT_DOCUMENTATION_TK;}
<FIELD_TYPE>EFFECTS			{return FT_EFFECTS_TK;}
<FIELD_TYPE>ACTION			{return FT_ACTION_TK;}

<NODE_TYPE>PROCESS			{return NT_PROCESS_TK;}
<NODE_TYPE>START			{return NT_START_TK;}
<NODE_TYPE>END				{return NT_END_TK;}
<NODE_TYPE>ELSE				{return NT_ELSE_TK;}
<NODE_TYPE>THEN				{return NT_THEN_TK;}
<NODE_TYPE>IF				{return NT_IF_TK;}

<EDGE_TYPE>GOAL			{return ET_GOAL_TK;}
<EDGE_TYPE>ELSE			{return ET_ELSE_TK;}
<EDGE_TYPE>THEN			{return ET_THEN_TK;}
<EDGE_TYPE>IF			{return ET_IF_TK;}

<ACTION_TYPE>\*=\*			{return SPEC_ACT_TK;}







:[Ii][Nn][Vv][Oo][Cc][Aa][Tt][Ii][Oo][Nn]		{return TFT_INVOCATION_TK;}
:[Bb][Oo][Dd][Yy]					{return TFT_BODY_TK;}
:[Cc][Oo][Nn][Tt][Ee][Xx][Tt]				{return TFT_CONTEXT_TK;}
:[Cc][Aa][Ll][Ll]				{return TFT_CALL_TK;}
:[Ss][Ee][Tt][Tt][Ii][Nn][Gg]				{return TFT_SETTING_TK;}
:[Pp][Rr][Oo][Pp][Ee][Rr][Tt][Ii][Ee][Ss]		{return TFT_PROPERTIES_TK;}
:[Dd][Oo][Cc][Uu][Mm][Ee][Nn][Tt][Aa][Tt][Ii][Oo][Nn]	{return TFT_DOCUMENTATION_TK;}
:[Ee][Ff][Ff][Ee][Cc][Tt][Ss]				{return TFT_EFFECTS_TK;}
:[Aa][Cc][Tt][Ii][Oo][Nn]				{return TFT_ACTION_TK;}

[Dd][Ee][Ff][Kk][Aa]					{return DEFOP_TK;}
[Dd][Ee][Ff][Oo][Pp]					{return DEFOP_TK;}
\/\/							{return PAR_TK;}
[Ww][Hh][Ii][Ll][Ee]					{return WHILE_TK;}
[Dd][Oo]						{return DO_TK;}
[Ii][Ff]						{return IF_TK;}
[Ee][Ll][Ss][Ee]					{return ELSE_TK;}
[Bb][Rr][Ee][Aa][Kk]					{return BREAK_TK;}
[Gg][Oo][Tt][Oo]					{return GOTO_TK;}
[Ll][Aa][Bb][Ee][Ll]					{return LABEL_TK;}
[Ee][Ll][Ss][Ee][Ii][Ff]				{return ELSEIF_TK;}

<COLLECT_COMMENT>{comment}		{ NEWSTR(oprs_yytext,oprs_yylval.string);
					  return COMMENT_TK;}












^\.\n		{ parser_line_number[parser_index]++;
                  return RESET_DOT_TK;} 


{real}		|
{real}{exp}    	{ sscanf(oprs_yytext,"%lf",&oprs_yylval.real);
		  return REAL_TK;}
{pointer}       { sscanf(oprs_yytext+2,"%x", (unsigned int *)&oprs_yylval.pointer); 
		  return POINTER_TK;}
{long_long}       { sscanf(oprs_yytext,"%lld", &oprs_yylval.long_long);
		  return LONG_LONG_TK;}
{integer}       { sscanf(oprs_yytext,"%d", &oprs_yylval.integer);
		  return INTEGER_TK;}
{comment}	;
{qstring}	{ NEWQSTR(oprs_yytext,oprs_yylval.string);
		  return QSTRING_TK;}

\|\|		{ oprs_yylval.string = or_sym;
		  return SYMBOL_TK;}
&		{ oprs_yylval.string = and_sym;
		  return SYMBOL_TK;}
~		{ oprs_yylval.string = not_sym;
		  return SYMBOL_TK;}


{lvar}		{ DECLARE_VAR(oprs_yytext,oprs_yylval.string);
		  return LOGICAL_VAR_TK;}
{pvar} |
{gpvar}		{ DECLARE_VAR(oprs_yytext,oprs_yylval.string);
		  return PROGRAM_VAR_TK;}


\+>		{  oprs_yylval.string = cond_add_sym;
		  return SYMBOL_TK;}
->		{  oprs_yylval.string = cond_del_sym;
		  return SYMBOL_TK;}
=>	|

[Aa][Ss][Ss][Ee][Rr][Tt]	|
[Cc][Oo][Nn][Cc][Ll][Uu][Dd][Ee]	{  oprs_yylval.string = temp_conclude_sym;
		  return SYMBOL_TK;}
~>	|
[Rr][Ee][Tt][Rr][Aa][Cc][Tt] 		{  oprs_yylval.string = retract_sym;
		  return SYMBOL_TK;}
!	|
[Aa][Cc][Hh][Ii][Ee][Vv][Ee] 		{  oprs_yylval.string = achieve_sym;
		  return SYMBOL_TK;}
\?	|
[Tt][Ee][Ss][Tt]	 		{  oprs_yylval.string = test_sym;
		  return SYMBOL_TK;}
#	|
[Pp][Rr][Ee][Ss][Ee][Rr][Vv][Ee]	{  oprs_yylval.string = preserve_sym;
		  return SYMBOL_TK;}
\^	|
[Ww][Aa][Ii][Tt]	 		{  oprs_yylval.string = twait_sym;
		  return SYMBOL_TK;}
\%	|
[Mm][Aa][Ii][Nn][Tt][Aa][Ii][Nn]	{  oprs_yylval.string = maintain_sym;
		  return SYMBOL_TK;}
\<>	|
[Cc][Aa][Ll][Ll]			{  oprs_yylval.string = call_sym;
		  return SYMBOL_TK;}


{oplisp}        { return OP_LISP_TK;}
{cplisp}        { return CP_LISP_TK;}
{opar}          { return OP_ARRAY_TK;}
{cpar}          { return CP_ARRAY_TK;}


t	|
T		{ oprs_yylval.string = lisp_t_sym;
		  return SYMBOL_TK;}
[nN][iI][lL]	{ oprs_yylval.string = nil_sym;
		  return SYMBOL_TK;}

{id} |
{idbar}		{ DECLARE_ID(oprs_yytext,oprs_yylval.string);
		  return SYMBOL_TK;}

{op}        	{ return OPENP_TK;}
{cp}        	{ return CLOSEP_TK;}

{nl}	    	{parser_line_number[parser_index]++;}

.		{warning("unexpected character.");}


%%
#include "yy-funct.c"

void yy_begin_0()
{
     BEGIN 0;
}

void yy_begin_COMMAND()
{
     BEGIN COMMAND;
}

void yy_begin_OPF_VERSION(void)
{
     BEGIN OPF_VERSION;
}

void yy_begin_NODE_TYPE(void)
{
     BEGIN NODE_TYPE;
}

void yy_begin_FIELD_TYPE(void)
{
     BEGIN FIELD_TYPE;
}

void yy_begin_ACTION_TYPE(void)
{
     BEGIN ACTION_TYPE;
}

void yy_begin_EDGE_TYPE(void)
{
     BEGIN EDGE_TYPE;
}

void yy_begin_COLLECT_COMMENT(void)
{
     BEGIN COLLECT_COMMENT;
}

